unit ConfigDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, IniFiles,
  //
  ATScreenSaver,
  //
  stdDialogs, stdFiles;

type
  TBrowserSaverConfigDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    URLListBox: TGroupBox;
    URLList: TMemo;
    Label1: TLabel;
    URLReloadTime: TEdit;
    URLReloadTimeUpDown: TUpDown;
    ShowConfigs: TGroupBox;
    ShowURL: TCheckBox;
    ShowClock: TCheckBox;
    EraseSection: TButton;
    Label2: TLabel;
    BackColor: TColorBox;
    Label3: TLabel;
    ForeColor: TColorBox;
    EnableScroll: TCheckBox;
    Label4: TLabel;
    URLShowTime: TEdit;
    URLShowTimeUpDown: TUpDown;
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure EraseSectionClick(Sender: TObject);
  private
    { Private 錾 }
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public 錾 }
  end;

var
  BrowserSaverConfigDlg: TBrowserSaverConfigDlg;

implementation

uses Registry, Main;

{$R *.dfm}

procedure TBrowserSaverConfigDlg.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := hWndScreenSaverParent;
end;

procedure TBrowserSaverConfigDlg.FormCreate(Sender: TObject);
var
  i : Integer;
  fl: TStringList;
begin
  with TRegIniFile.Create(FileName) do
  try
    URLReloadTimeUpDown.Position:= ReadInteger(Application.Title, 'RefreshTime', 1);
    URLShowTimeUpDown.Position  := ReadInteger(Application.Title, 'URLShowTime', 5);
    ShowURL.Checked             := ReadBool(Application.Title, 'ShowURL', False);
    ShowClock.Checked           := ReadBool(Application.Title, 'ShowClock', False);
    EnableScroll.Checked        := ReadBool(Application.Title, 'EnableScroll', True);
    BackColor.Selected          :=
      StringToColor(ReadString(Application.Title, 'BackColor', 'clBtnFace'));
    ForeColor.Selected          :=
      StringToColor(ReadString(Application.Title, 'ForeColor', 'clWindowText'));
    URLList.Lines.BeginUpdate;
    try
      ReadSectionValues(Application.Title + '\URLList', URLList.Lines);
      for i := 0 to URLList.Lines.Count - 1 do
        URLList.Lines[i] := URLList.Lines.Values[URLList.Lines.Names[i]];
    finally
      URLList.Lines.EndUpdate;
    end;
  finally
    Free;
  end;
  // Ô߃LbVfBNgۂ
  fl := TStringList.Create;
  try
    EnumFile(cachedir + '*.bmp', faAnyFile, fl);
    for i := 0 to fl.Count - 1 do
      DeleteFile(cachedir + fl[i]);
  finally
    fl.Free;
  end;

end;

procedure TBrowserSaverConfigDlg.OKBtnClick(Sender: TObject);
var i: Integer;
begin
  with TRegIniFile.Create(FileName) do
  try
    WriteInteger(Application.Title, 'RefreshTime', URLReloadTimeUpDown.Position);
    WriteInteger(Application.Title, 'URLShowTime', URLShowTimeUpDown.Position);
    WriteBool(Application.Title, 'ShowURL', ShowURL.Checked);
    WriteBool(Application.Title, 'ShowClock', ShowClock.Checked);
    WriteBool(Application.Title, 'EnableScroll', EnableScroll.Checked);
    WriteString(Application.Title, 'BackColor', ColorToString(BackColor.Selected));
    WriteString(Application.Title, 'ForeColor', ColorToString(ForeColor.Selected));
    EraseSection(Application.Title + '\URLList');
    for i := 0 to URLList.Lines.Count - 1 do
      WriteString(Application.Title + '\URLList', IntToStr(i + 1), URLList.Lines[i]);
  finally
    Free;
  end;
end;

procedure TBrowserSaverConfigDlg.EraseSectionClick(Sender: TObject);
begin
  if Confirm('̃XN[Z[o[̃WXgݒAׂč폜܂') then
    with TRegIniFile.Create(FileName) do begin try
      EraseSection(Application.Title);
      Alert('ɍ폜܂B'#13'"LZ"ă_CAOĂB');
      finally
        Free;
      end;
    end;
end;

end.

