unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Contnrs, ExtCtrls, OleCtrls, Math, Registry,
  //
  ATScreenSaver;
// fobO̍ۂ́AATScreenSaver.InitializeFalseɂ邱
type
  TScreenSaverDisplayForm = class(TForm)
    Timer: TTimer;
    ATScreenSaver: TATScreenSaver;
    procedure TimerTimer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ATScreenSaverCreateConfigForm(Sender: TObject;
      var ConfigForm: TCustomForm);
    procedure ATScreenSaverClose(Sender: TObject);
    procedure ATScreenSaverRunNormal(Sender: TObject; hWnd,
      hWndParent: HWND);
    procedure ATScreenSaverRunPreview(Sender: TObject; hWnd,
      hWndParent: HWND);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
  private
    { Private 錾 }

    FURLList        : TStringList;
    FShowCursor     : Integer;
    FNextReloadTime : Cardinal;
    FScrollCount    : Integer;
    FReloadTime     : Integer;
    FURLShowTime    : Integer;
    FShowURL        : Boolean;
    FShowClock      : Boolean;
    FEnableScroll   : Boolean;
    FBitmap         : TBitmap;
    FHasFileTime    : Integer;
  public
    { Public 錾 }
    property  URLList       : TStringList   read  FURLList;
    property  ShowCursor    : Integer       read  FShowCursor;
    property  NextReloadTime: Cardinal      read  FNextReloadTime;
    property  ScrollCount   : Integer       read  FScrollCount;
    property  ReloadTime    : Integer       read  FReloadTime;
    property  URLShowTime   : Integer       read  FURLShowTime;
    property  ShowURL       : Boolean       read  FShowURL;
    property  ShowClock     : Boolean       read  FShowClock;
    property  EnableScroll  : Boolean       read  FEnableScroll;
    property  Bitmap        : TBitmap       read  FBitmap;
//    property  HasFileTime   : Integer       read  FHasFileTime;
  end;

var
  ScreenSaverDisplayForm: TScreenSaverDisplayForm;
const
  FileName          = 'Software\݂\';

function appdir: String;
function cachedir: String;
function cachefile(Index: Integer): String;
implementation

uses Working, ConfigDlg;

{$R *.dfm}

{ TScreenSaverDisplayForm }

(* tH[Cxg *)

procedure TScreenSaverDisplayForm.FormPaint(Sender: TObject);
var
  b     : TBitmap;
  size  : TSize;
  function GetCenter(Size, Content: Integer): Integer;
  begin
    Result := Size div 2 - Content div 2;
  end;
  function URLString(): String;
  begin
    Result := URLList[ShowCursor];

    if FHasFileTime > 0 then
      Result := Result + Format('(%st)',
        [DateTimeToStr(FileDateToDateTime(FHasFileTime))])
    else
      Result := Result + '(擾)';
  end;
begin
  if ATScreenSaver.Normal then begin
    b   := FBitmap;
    if b.Empty then begin
      // 摜Ȃꍇ
      size := Canvas.TextExtent('ǂݍݒłB΂炭܂');
      Canvas.TextOut(
        GetCenter(Width, size.cx), GetCenter(Height, size.cy),
        'ǂݍݒłB΂炭܂');
    end else
      // Weby[W\
      Canvas.Draw(
        Max(Width div 2 - b.Width div 2, 0),
        IfThen(b.Height < Height, Max(Height div 2 - b.Height div 2, 0), -FScrollCount),
        b);
    // URL\
    if FShowURL then
      Canvas.TextOut(5, 5, URLString);
    // v\
    if FShowClock then begin
      size := Canvas.TextExtent(FormatDateTime('AM/PM hh:nn:ss', Now));
      Canvas.TextOut(
        Width - size.cx - 5, Height - size.cy - 5,
        FormatDateTime('AM/PM hh:nn:ss', Now));
    end;
  end else if ATScreenSaver.Preview then begin
    Canvas.TextOut(5, 5, Application.Title);
  end;
end;

procedure TScreenSaverDisplayForm.FormShortCut(var Msg: TWMKey;
  var Handled: Boolean);
begin
  // BR}h
  case Msg.CharCode of
    Ord('Z'), Ord('X'):
      Handled := True;
  end;
end;

(* ^C}[ *)

procedure TScreenSaverDisplayForm.TimerTimer(Sender: TObject);
  procedure UpdateCursor(NewCursor: Integer);
  begin
    FShowCursor := NewCursor;
    FScrollCount:= 0;
    Timer.Tag   := 0;
    if FileExists(cachefile(FShowCursor)) then begin
      Bitmap.LoadFromFile(cachefile(ShowCursor));
      FHasFileTime := FileAge(cachefile(ShowCursor));
    end else
      Bitmap.Assign(nil);
  end;
begin
  // BR}hX ĂԂ͍XVXgbv(v͓)
  if GetKeyState(Ord('X')) >= 0 then begin
    // 摜Ȃ or 摜Âꍇ͍XV
    if Bitmap.Empty or (FileAge(cachefile(ShowCursor)) > FHasFileTime) then
      UpdateCursor(ShowCursor);

    // XN[\p(BR}hZ ꂽ瑦Ɏ̃y[W)
    if (GetKeyState(Ord('Z')) >= 0) and FEnableScroll and (FScrollCount < Bitmap.Height - Height) then
      Inc(FScrollCount, Height div 3)
    else if (GetKeyState(Ord('Z')) >= 0) and (Timer.tag < FURLShowTime) then
      Timer.Tag := Timer.Tag + 1
    else if FShowCursor < URLList.Count - 1 then
      UpdateCursor(FShowCursor + 1)
    else
      UpdateCursor(0);
    // tbVp
    if FNextReloadTime < GetTickCount then begin
      FNextReloadTime := GetTickCount + Cardinal(FReloadTime * 1000 * 60);
      WorkingForm.BeginLoading;
    end;
  end;
  Invalidate;
end;

(* ATScreenSaver *)

procedure TScreenSaverDisplayForm.ATScreenSaverRunNormal(Sender: TObject;
  hWnd, hWndParent: HWND);
var
  i : Integer;
begin
  CreateDir(cachedir);
  FURLList      :=  TStringList.Create;
  FBitmap       :=  TBitmap.Create;
  DoubleBuffered:=  True;
  WorkingForm   :=  TWorkingForm.Create(Self);
  WorkingForm.Show;
  with TRegIniFile.Create(FileName) do
  try
    FReloadTime   := ReadInteger(Application.Title, 'RefreshTime', 1);
    FURLShowTime  := ReadInteger(Application.Title, 'URLShowTime', 5);
    FShowURL      := ReadBool(Application.Title, 'ShowURL', False);
    FShowClock    := ReadBool(Application.Title, 'ShowClock', False);
    FEnableScroll := ReadBool(Application.Title, 'EnableScroll', True);
    Color         :=
      StringToColor(ReadString(Application.Title, 'BackColor', 'clBtnFace'));
    Font.Color    :=
      StringToColor(ReadString(Application.Title, 'ForeColor', 'clWindowText'));
    URLList.BeginUpdate;
    try
      ReadSectionValues(Application.Title + '\URLList', URLList);
      for i := 0 to URLList.Count - 1 do
        URLList[i] := URLList.Values[URLList.Names[i]];
    finally
      URLList.EndUpdate;
    end;
  finally
    Free;
  end;
  Timer.Enabled   := True;
  WorkingForm.BeginLoading;
  FScrollCount    := Height div 10 * -1;
  FNextReloadTime := GetTickCount + Cardinal(FReloadTime * 1000 * 60);
end;

procedure TScreenSaverDisplayForm.ATScreenSaverRunPreview(Sender: TObject;
  hWnd, hWndParent: HWND);
begin
  Color           := clBlack;
  Font.Color      := clWhite;
end;

procedure TScreenSaverDisplayForm.ATScreenSaverClose(Sender: TObject);
begin
  if ATScreenSaver.Normal then begin
    WorkingForm.Release;
    FBitmap.Free;
    FURLList.Free;
  end;
end;

procedure TScreenSaverDisplayForm.ATScreenSaverCreateConfigForm(
  Sender: TObject; var ConfigForm: TCustomForm);
begin
  ConfigForm := TBrowserSaverConfigDlg.Create(Self);
end;

(* NXɑȂ\bh *)

function appdir: String;
begin
  Result := IncludeTrailingPathDelimiter(ExtractFileDir(Application.ExeName));
end;

function cachedir: String;
begin
  Result := IncludeTrailingPathDelimiter(appdir + 'BrowserSaverCache');
end;

function cachefile(Index: Integer): String;
begin
  Result := Format('%s%d.bmp', [cachedir, Index]);
end;

end.

