unit Working;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, MSHTML, ActiveX, stdDialogs,
  Main;

type
  TWorkingForm = class(TForm)
    Web: TWebBrowser;
    procedure WebDocumentComplete(Sender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
  private
    { Private 錾 }
    FLoadCursor : Integer;
    FWorking    : Boolean;
  public
    { Public 錾 }
    procedure BeginLoading();
  end;

var
  WorkingForm: TWorkingForm;

implementation

uses Math;

{$R *.dfm}

{ TWorkingForm }

procedure TWorkingForm.BeginLoading();
begin
  if not FWorking then begin
    FLoadCursor := 0;
    Web.Navigate('about:blank');
  end;
end;

procedure TWorkingForm.WebDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
  // http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=33#0247.txt Ql
var
  body        : OleVariant;
  w, h        : Integer;
  Bitmap      : TBitmap;
begin
  FWorking := True;
  if URL <> 'about:blank' then begin
    // y[WC[W̎擾
    body  := (Web.Document as IHTMLDocument2).body;
    Bitmap:= TBitmap.Create;
    try
      w := body.scrollWidth + 16;
      h := body.scrollHeight + 16;
      body.style.overflow := 'hidden';
      body.style.border   := '0';
      with ScreenSaverDisplayForm do
      if not EnableScroll then begin
        w := Min(w, Width);
        h := Min(h, Height);
      end;
      Bitmap.Width  := w;
      Bitmap.Height := h;

      // ݒlۑăTCY܂B
      Web.ControlInterface.Width  := w;
      Web.ControlInterface.Height := h;

      // `悵܂B
      OleDraw(Web.ControlInterface, DVASPECT_DOCPRINT, Bitmap.Canvas.Handle,
              Rect(0, 0, Bitmap.Width, Bitmap.Height));
      Bitmap.SaveToFile(cachefile(FLoadCursor - 1));
    finally
      Bitmap.Free;
    end;
  end;
  if FLoadCursor < ScreenSaverDisplayForm.URLList.Count then begin
    // ̂ǂ݂ɍs
    Web.Navigate(ScreenSaverDisplayForm.URLList[FLoadCursor]);
    Inc(FLoadCursor)
  end else
    FWorking := False;
end;

end.
